﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private fx As JFX
	Private clvbas As CustomListView
	Private clvtpl As CustomListView
	Private clvvar As CustomListView
	Private clvvariables As CustomListView
	Private lblcodefilename As Label
	Private lbltempfilename As Label
	Private pnexit As Pane
	Private pngenerate As Pane
	Private pnleft As Pane
	Private pnload As Pane
	Private pnmessages As Pane
	Private pnmiddle As Pane
	Private pnright As Pane
	Private pnsave As Pane
	Private pnvariables As Pane
	Private pnvars As Pane
	Private rb1 As RadioButton
	Private rb2 As RadioButton
	Private rb3 As RadioButton
	Private sbtnvaradd As SwiftButton
	Private sbtnvarload As SwiftButton
	Private sbtnvarsave As SwiftButton
	Private tacode As TextArea
	Private wvvars As WebView
	Private fchoose As FileChooser
	Private lblmessages As Label
	Public templatefilesfolder As String
	Public generatedfilesfolder As String
	Public varfilesfolder As String
	Public layoutfilesfolder As String
	Private varcnt As Int
	Public varmap As Map
	Private btnvardel As Button
	Private tfcontent As TextField
	Private tfname As TextField
	Private hclass As htmlclass
	Private objtpl As template
	Public templatefile As String
	Public resulttext As String
	Public generatedfile As String
	Private rb4 As RadioButton
	Private clvlay As CustomListView
	Private btnconvert As Button
	Private btnshowlayout As Button
	Private pnlayout As Pane
	Private rbtobal As RadioButton
	Private rbtojson As RadioButton
	Private pnimage As Pane
	Public layheight As Int
	Public laywidth As Int
	Public cnvs As B4XCanvas
	Private tpfont As B4XFont
	Private converter As BalConverter
	Private btnloadlayout As Button
	Public panemap As Map
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"pmtemplates")
	fchoose.Initialize
	xui.SetDataFolder("pmtemplates")
	File.MakeDir(xui.DefaultFolder,"templatefiles")
	File.MakeDir(xui.DefaultFolder,"generatedfiles")
	File.MakeDir(xui.DefaultFolder,"varfiles")
	File.MakeDir(xui.DefaultFolder,"layoutfiles")
	templatefilesfolder = File.DirData("pmtemplates") & "\templatefiles"
	generatedfilesfolder = File.DirData("pmtemplates") & "\generatedfiles"
	varfilesfolder = File.DirData("pmtemplates") & "\varfiles"
	layoutfilesfolder = File.DirData("pmtemplates") & "\layoutfiles"
	lblmessages.Text = ""
	varmap.Initialize
	varcnt = 0
	hclass.Initialize
	templatefile = ""
	tpfont = fx.DefaultFont(16)
	panemap.Initialize
End Sub
Private Sub B4XPage_Appear
	fill_clvtpl
	fill_clvvar
	fill_clvbas
	fill_clvlay
	show_selected_clv
End Sub
Private Sub show_selected_clv
	pnmessages.Visible = True
	pnlayout.Visible = False
	If rb1.Selected = True Then
		clvtpl.AsView.Visible = True
		clvvar.AsView.Visible = False
		clvbas.AsView.Visible = False
		clvlay.AsView.Visible = False
	End If
	If rb2.Selected = True Then
		clvtpl.AsView.Visible = False
		clvvar.AsView.Visible = True
		clvbas.AsView.Visible = False
		clvlay.AsView.Visible = False
	End If
	If rb3.Selected = True Then
		clvtpl.AsView.Visible = False
		clvvar.AsView.Visible = False
		clvbas.AsView.Visible = True
		clvlay.AsView.Visible = False
	End If
	If rb4.Selected = True Then
		clvtpl.AsView.Visible = False
		clvvar.AsView.Visible = False
		clvbas.AsView.Visible = False
		clvlay.AsView.Visible = True
		pnmessages.Visible = False
		pnlayout.Visible = True
	End If
End Sub
Sub codebuttons_MouseClicked (EventData As MouseEvent)
	Dim pn As Pane = Sender
	Dim tag As String = pn.Tag
	code_action(tag)
End Sub
Sub code_action(tag As String)
	Select tag
		Case "exit"
			ExitApplication
		Case "load"
			pnvars.Visible = False
			show_opendialog
		Case "save"
			pnvars.Visible = False
			If tacode.Text <> "" Then
				show_savedialog
			End If
		Case "variables"
			If lblcodefilename.Text.Trim.EndsWith(".tpl") = False Then
				xui.MsgboxAsync("Load a template file first!","Variables")
				Return
			End If
			pnvars.Visible = True
			fill_clvvariables
		Case "generate"
			pnvars.Visible = False
			generate
		Case "clear"
			pnvars.Visible = False
			tacode.Text = ""
			lblmessages.Text = ""
			lblcodefilename.Text = ""
			clvvariables.Clear
			lbltempfilename.Text = ""
			wvvars.LoadHtml("")
			templatefile = ""
			varmap.Clear
			pnimage.RemoveAllNodes
			pnimage.Visible = False
			tacode.PrefWidth = 840dip
			B4XPage_Appear
	End Select
End Sub
private Sub show_opendialog
	fchoose.setExtensionFilter("Template", Array As String("*.tpl","*.bas","*.var","*.json"))
	Dim filename As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename = "" Then Return
	Dim filepath As String = filename.SubString2(0,filename.LastIndexOf("\"))
	filename = filename.SubString(filename.LastIndexOf("\")+1)
	Log(filename)
	Log(filepath)
	lblcodefilename.Text = "  " & filename
	Dim strtxt As String = File.ReadString(filepath, filename)
	If filename.EndsWith(".bal") Or filename.EndsWith(".bil") Or filename.EndsWith(".bjl") Or filename.EndsWith(".bak") Then
		tacode.text = CRLF & "This is a binary file format." & CRLF
	Else
		tacode.Text = strtxt		
	End If
	lblmessages.Text = lblmessages.Text & filename & " loaded." & CRLF
	If lblcodefilename.Text.Trim.EndsWith(".tpl") Then templatefile = lblcodefilename.Text.Trim
End Sub
Private Sub show_savedialog
	If lblcodefilename.Text.Trim.EndsWith(".bal") Or lblcodefilename.Text.Trim.EndsWith(".bil") Or lblcodefilename.Text.Trim.EndsWith(".bjl") Or lblcodefilename.Text.Trim.EndsWith(".bak") Then
		tacode.text = CRLF & "This file format can't be saved." & CRLF
		Return
	End If	
	fchoose.InitialDirectory = xui.DefaultFolder
	fchoose.InitialFileName = lblcodefilename.Text.Trim
	Dim filename As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename = "" Then Return
	Dim filepath As String = filename.SubString2(0,filename.LastIndexOf("\"))
	filename = filename.SubString(filename.LastIndexOf("\")+1)
	Log(filename)
	Log(filepath)
	If filename <> "" Then
		If lblcodefilename.Text.Trim.EndsWith(".json") Then
			Dim jstr As String = File.ReadString(layoutfilesfolder, lblcodefilename.Text.Trim)
			File.WriteString(layoutfilesfolder, filename,jstr)
			lblmessages.Text = lblmessages.Text & filename & " saved." & CRLF
		Else
			File.WriteString(filepath, filename,tacode.text)
			lblmessages.Text = lblmessages.Text & filename & " saved." & CRLF				
		End If
	End If		
	Sleep(1000)
	code_action("clear")
End Sub
Private Sub fill_clvtpl
	clvtpl.Clear
	Private lst As List = File.ListFiles(templatefilesfolder)
	For i = 0 To lst.Size -1
		clvtpl.AddTextItem(lst.Get(i),lst.Get(i))
	Next
End Sub
Private Sub fill_clvvar
	clvvar.Clear
	Private lst As List = File.ListFiles(varfilesfolder)
	For i = 0 To lst.Size -1
		clvvar.AddTextItem(lst.Get(i),lst.Get(i))
	Next
End Sub
Private Sub fill_clvbas
	clvbas.Clear
	Private lst As List = File.ListFiles(generatedfilesfolder)
	For i = 0 To lst.Size -1
		clvbas.AddTextItem(lst.Get(i),lst.Get(i))
	Next
End Sub
Private Sub fill_clvlay
	clvlay.Clear
	Private lst As List = File.ListFiles(layoutfilesfolder)
	For i = 0 To lst.Size -1
		clvlay.AddTextItem(lst.Get(i),lst.Get(i))
	Next
End Sub
Private Sub fill_clvvariables
	clvvariables.Clear
	Dim pn As Pane = set_clvvariables_item(varcnt)
	clvvariables.Add(pn,varcnt)
End Sub
Private Sub set_clvvariables_item(cnt As Int) As Pane
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0dip, 0dip, 400dip,85dip)
	p.LoadLayout("clvvariablesitem_layout")
	btnvardel.Tag = cnt
	Return p
End Sub
Private Sub set_clvvariables
	varmap.Clear
	objtpl.Initialize(tacode.text,varmap)
	varmap = objtpl.find_placeholders
	Log(varmap)
	If templatefile <> "" Then
		Dim vmap As Map
		vmap.Initialize
		Dim fname As String = templatefile.SubString2(0,templatefile.LastIndexOf("."))
		If File.Exists(varfilesfolder,fname & ".var") Then
			vmap = File.ReadMap(varfilesfolder,fname& ".var")
			For Each k As String In varmap.Keys
				varmap.Put(k,vmap.Get(k))
			Next
		End If
		Log(varmap)
	End If
	fill_clvvariables_from_varmap
End Sub
Private Sub fill_clvvariables_from_varmap
	clvvariables.Clear
	varcnt = 0
	For i = 0 To varmap.Size - 1
		Dim pn As Pane = set_clvvariables_item(varcnt)
		tfname.Text = varmap.GetKeyAt(i)
		tfcontent.Text = varmap.GetValueAt(i)
		clvvariables.Add(pn,varcnt)
		varcnt = varcnt + 1
	Next
	clvvariables.sv.ScrollViewContentHeight = varcnt*85 + 150dip
End Sub
Private Sub sbtnvarsave_Click
	If templatefile = "" Then Return
	Dim mp As Map
	mp.Initialize
	For i = 0 To clvvariables.Size - 1
		Dim name As String = clvvariables.GetPanel(i).GetView(0).Text
		Dim content As String = clvvariables.GetPanel(i).GetView(1).Text
		mp.Put(name,content)
	Next
	Dim fname As String = templatefile.SubString2(0,templatefile.LastIndexOf("."))
	File.WriteMap(varfilesfolder, fname & ".var",mp)
	varmap = mp
End Sub
Private Sub sbtnvarload_Click
	set_clvvariables
	If tacode.Text <> "" And templatefile <> "" Then
		lbltempfilename.Text = "  " & templatefile
		Dim strtxt As String = tacode.Text
		strtxt = strtxt.Replace("[@","<span class='w3-yellow'>" & "[@" & "</span>")
		Dim htmlstring As String = hclass.set_htmlpage(strtxt,"html")
		wvvars.LoadHtml(htmlstring)
	End If
End Sub
Private Sub sbtnvaradd_Click
	Dim pn As Pane = set_clvvariables_item(varcnt)
	clvvariables.InsertAt(0,pn,0)
	For i = 0 To clvvariables.Size - 1
		clvvariables.GetPanel(i).GetView(2).Tag = i
	Next
	clvvariables.sv.ScrollViewContentHeight = clvvariables.Size*85 + 100dip
End Sub
Private Sub clvvar_ItemClick (Index As Int, Value As Object)
	Dim fname As String = clvvar.GetValue(Index)
	tacode.Text = File.ReadString(varfilesfolder, fname)
	lblcodefilename.Text = "  " & fname
End Sub
Private Sub clvvar_ItemLongClick (Index As Int, Value As Object)
	Dim fname As String = clvvar.GetValue(Index)
	Dim msg As Object = xui.Msgbox2Async("Delete " & fname & " ?","Delete","Yes","Cancel","No",Null)
	Wait For (msg) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		File.Delete(varfilesfolder,fname)
	End If
	code_action("clear")
End Sub
Private Sub clvtpl_ItemClick (Index As Int, Value As Object)
	pnvars.Visible = False
	lbltempfilename.Text = ""
	wvvars.LoadHtml("")
	varmap.Clear
	Dim fname As String = clvtpl.GetValue(Index)
	tacode.Text = File.ReadString(templatefilesfolder, fname)
	lblcodefilename.Text = "  " & fname
	If lblcodefilename.Text.Trim.EndsWith(".tpl") Then templatefile = lblcodefilename.Text.Trim
End Sub
Private Sub clvtpl_ItemLongClick (Index As Int, Value As Object)
	Dim fname As String = clvtpl.GetValue(Index)
	Dim msg As Object = xui.Msgbox2Async("Delete " & fname & " ?","Delete","Yes","Cancel","No",Null)
	Wait For (msg) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		File.Delete(templatefilesfolder,fname)
	End If
	code_action("clear")
End Sub
Private Sub clvbas_ItemClick (Index As Int, Value As Object)
	Dim fname As String = clvbas.GetValue(Index)
	tacode.Text = File.ReadString(generatedfilesfolder, fname)
	lblcodefilename.Text = "  " & fname
End Sub
Private Sub clvbas_ItemLongClick (Index As Int, Value As Object)
	Dim fname As String = clvbas.GetValue(Index)
	Dim msg As Object = xui.Msgbox2Async("Delete " & fname & " ?","Delete","Yes","Cancel","No",Null)
	Wait For (msg) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		File.Delete(generatedfilesfolder,fname)
	End If
	code_action("clear")
End Sub
Private Sub clvlay_ItemClick (Index As Int, Value As Object)
	Dim fname As String = clvlay.GetValue(Index)
	lblcodefilename.Text = "  " & fname
	If fname.EndsWith(".bal") Or fname.EndsWith(".bil") Or fname.EndsWith(".bjl") Or fname.EndsWith(".bak") Then
		tacode.text = CRLF & "This is a binary file format." & CRLF
	Else
		get_vars_from_json_layout(fname)
		tacode.Text = tacode.Text & CRLF & File.Readstring(layoutfilesfolder,fname)
	End If
	
End Sub
Private Sub clvlay_ItemLongClick (Index As Int, Value As Object)
	Dim fname As String = clvlay.GetValue(Index)
	Dim msg As Object = xui.Msgbox2Async("Delete " & fname & " ?","Delete","Yes","Cancel","No",Null)
	Wait For (msg) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		File.Delete(layoutfilesfolder,fname)
	End If
	code_action("clear")
End Sub
Private Sub rb1_SelectedChange(Selected As Boolean)
	code_action("clear")
End Sub
Private Sub rb2_SelectedChange(Selected As Boolean)
	code_action("clear")
End Sub
Private Sub rb3_SelectedChange(Selected As Boolean)
	code_action("clear")
End Sub
Private Sub rb4_SelectedChange(Selected As Boolean)
	code_action("clear")
End Sub
Private Sub btnvardel_Click
	Dim btn As Button = Sender
	Log(btn.Tag)
	clvvariables.RemoveAt(btn.Tag)
	For i = 0 To clvvariables.Size - 1
		clvvariables.GetPanel(i).GetView(2).Tag = i
	Next
	varcnt = i
End Sub
Private Sub generate
	If templatefile = "" Then
		xui.MsgboxAsync("There is no template file loaded!","Generate")
		Return
	End If
	If varmap.Size = 0 Then
		xui.MsgboxAsync("You need to load the variables for this template!","Generate")
		Return
	End If

	If tacode.text <> "" And varmap.Size > 0 And templatefile <> "" Then
		objtpl.Initialize(tacode.text,varmap)
		objtpl.process_loops
		resulttext = objtpl.tpl_text
		resulttext = objtpl.replace_placeholders
		Dim fname As String = templatefile.SubString2(0,templatefile.LastIndexOf("."))
		generatedfile = fname & ".bas"
		tacode.Text = resulttext
		fchoose.InitialDirectory = generatedfilesfolder
		fchoose.InitialFileName = generatedfile
		Dim filename As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
		If filename = "" Then
			varmap.Clear
			code_action("clear")
			Return
		End If
		Dim filepath As String = filename.SubString2(0,filename.LastIndexOf("\"))
		filename = filename.SubString(filename.LastIndexOf("\")+1)
		Log(filename)
		Log(filepath)
		If filename <> "" Then
			File.WriteString(filepath, filename,resulttext)
			lblmessages.Text = lblmessages.Text & filename & " saved." & CRLF
		End If
		rb3.Selected = True
		code_action("clear")
	End If
End Sub
Private Sub get_vars_from_json_layout(fname As String)
	tacode.Text = ""
	panemap.Clear
	pnimage.RemoveAllNodes
	cnvs.Initialize(pnimage)
	Dim strjson As String = File.Readstring(layoutfilesfolder,fname)
	If fname.EndsWith(".json") = False Then Return
	tacode.Text = "Information from the JSON layout file:" & CRLF
	Dim rtmap As Map = strjson.As(JSON).ToMap
	Dim variantsinfo As List = rtmap.Get("Variants")
	Dim variantmap As Map = variantsinfo.Get(0)
	layheight = variantmap.Get("Height")
	laywidth = variantmap.Get("Width")
	tacode.Text = tacode.Text & CRLF & "Height: " & layheight
	tacode.Text = tacode.Text & CRLF & "Width: " & laywidth
	Dim lhmap As Map = rtmap.Get("LayoutHeader")
	Dim chlst As List = lhmap.Get("ControlsHeaders")
	Dim namelst As List
	namelst.Initialize
	Dim typelst As List
	typelst.Initialize
	For i = 0 To chlst.Size -1
		Dim vmap As Map = chlst.Get(i)
		If vmap.Get("Name") <> "Main" Then
			namelst.Add(vmap.Get("Name"))
			typelst.Add(vmap.Get("DesignerType"))
		End If
	Next
	Dim strvnames As String = ""
	For i = 0 To namelst.Size -1
		If i < namelst.Size -1 Then
			strvnames = strvnames & namelst.Get(i) & ","
		Else
			strvnames = strvnames & namelst.Get(i)
		End If
	Next
	Dim strvtypes As String = ""
	For i = 0 To typelst.Size -1
		If i < typelst.Size -1 Then
			strvtypes = strvtypes & typelst.Get(i) & ","
		Else
			strvtypes = strvtypes & typelst.Get(i)
		End If
	Next
	tacode.Text = tacode.Text & CRLF & "Variable names: " & strvnames
	tacode.Text = tacode.Text & CRLF & "Variable types: " & strvtypes
	tacode.Text = tacode.Text & CRLF & "=========================="
	Dim dtmap As Map = rtmap.Get("Data")
	Dim kidsmap As Map = dtmap.Get(":kids")
	process_children(kidsmap)
	Log(panemap)
	For Each k As String In kidsmap.Keys
		Dim kidskidsmap As Map = kidsmap.Get(k)
		Dim childrenmap As Map = kidskidsmap.Get(":kids")
		If childrenmap.IsInitialized And childrenmap.Size > 0 Then
			process_children(childrenmap)
		End If		
	Next
	tacode.Text = tacode.Text & CRLF & "=========================="
End Sub
Private Sub process_children(cmap As Map)
	For Each k As String In cmap.Keys
		Log("process children key: " & k)
		Dim kmap As Map = cmap.Get(k)
		Dim pname As String = kmap.Get("parent")
		Dim kname As String = kmap.Get("name")
		Dim ktype As String = kmap.Get("type")
		Dim kidvariantmap As Map = kmap.Get("variant0")
		Dim topvar As Int = kidvariantmap.Get("top")
		Dim leftvar As Int = kidvariantmap.Get("left")
		Dim widthvar As Int = kidvariantmap.Get("width")
		Dim heightvar As Int = kidvariantmap.Get("height")
		Dim hanchor As Int = kidvariantmap.Get("hanchor")
		Dim vanchor As Int = kidvariantmap.Get("vanchor")
		tacode.Text = tacode.Text & CRLF & "Variable name: " & kname
		tacode.Text = tacode.Text & CRLF & "Parent name: " & pname
		tacode.Text = tacode.Text & CRLF & "Top position: " & topvar
		tacode.Text = tacode.Text & CRLF & "Left position: " & leftvar
		tacode.Text = tacode.Text & CRLF & "Width variable: " & widthvar
		tacode.Text = tacode.Text & CRLF & "Height variable: " & heightvar
		tacode.Text = tacode.Text & CRLF & "Horizontal anchor: " & hanchor
		tacode.Text = tacode.Text & CRLF & "Vertical anchor: " & vanchor
		tacode.Text = tacode.Text & CRLF & "----------"
		If ktype.StartsWith(".Pane") Then
			Dim pwidthvar As Int = widthvar
			Dim pheightvar As Int = heightvar
			If widthvar = 0 Then pwidthvar = laywidth
			If hanchor = 2 Then pwidthvar = laywidth - widthvar
			If heightvar = 0 Then pheightvar = layheight
			If vanchor = 2 Then pheightvar = layheight - heightvar
			Dim panevalues As String = topvar & "," & leftvar & "," & pwidthvar & "," & pheightvar
			panemap.Put(kname,panevalues)
		End If
		If vanchor = 2 And (pname = "Main" Or pname = "Activity") Then
			heightvar = layheight - heightvar - topvar
		End If
		If hanchor = 2  And (pname = "Main" Or pname = "Activity") Then
			widthvar = laywidth - widthvar - leftvar
		End If
		If vanchor = 1 Then
			topvar = layheight - topvar - heightvar
		End If
		If hanchor = 1  Then
			 leftvar = laywidth - leftvar - widthvar
		End If
		If panemap.ContainsKey(pname) Then
			Dim pvalues As String = panemap.Get(pname)		' top - left - width - height
			Dim pvallst As List = Regex.Split(",",pvalues)
			topvar = topvar + pvallst.Get(0)
			leftvar = leftvar + pvallst.Get(1)
			If vanchor = 2 Then
				If heightvar < 10 Then
					heightvar = pvallst.Get(3) - heightvar - topvar
				Else
					heightvar = layheight - heightvar - topvar
				End If
			End If
			If hanchor = 2  Then
				If widthvar < 10 Then
					widthvar = pvallst.Get(2) - widthvar - leftvar					
				Else
					widthvar = laywidth - widthvar - leftvar
				End If
			End If
		End If
		If widthvar = 0 Then widthvar = laywidth
		If heightvar = 0 Then heightvar = layheight
		Private rect As B4XRect
		leftvar = leftvar * 400 / laywidth
		topvar = topvar * 400 / layheight
		widthvar = widthvar * 400 / laywidth
		heightvar = heightvar * 400 / layheight
		rect.Initialize(leftvar,topvar,leftvar+widthvar,topvar+heightvar)
		Dim rcol As Int = Rnd(100,201)
		Dim gcol As Int = Rnd(100,201)
		Dim bcol As Int = Rnd(100,201)
		cnvs.DrawRect(rect,fx.Colors.To32Bit(fx.Colors.ARGB(255,rcol,gcol,bcol)), True, 1)
		cnvs.DrawText(kname,(leftvar+widthvar/2),(topvar+heightvar/2),tpfont,fx.Colors.To32Bit(fx.Colors.Black),"CENTER")
'		Log(kmap.ContainsKey(":kids"))
'		If kmap.ContainsKey(":kids") Then
'			Dim kkmap As Map = kmap.Get(":kids")
'			If kkmap.IsInitialized And kkmap.Size > 0 Then
'				process_children(kkmap)
'			End If
'		End If
	Next
End Sub
Private Sub btnshowlayout_Click
	If pnimage.Visible = True Then
		pnimage.Visible = False
		tacode.PrefWidth = 840dip
	Else
		pnimage.Visible = True
		tacode.PrefWidth = 420dip
	End If
End Sub
Private Sub btnloadlayout_Click
	fchoose.setExtensionFilter("Layout", Array As String("*.bal","*.bil","*.bjl"))
	Dim filename As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename = "" Then Return
	Dim filepath As String = filename.SubString2(0,filename.LastIndexOf("\"))
	filename = filename.SubString(filename.LastIndexOf("\")+1)
	Log(filename)
	Log(filepath)
	lblcodefilename.Text = "  " & filename
	If File.Exists(layoutfilesfolder,filename) Then
		Dim newfilename As String = DateTime.Now & "_" & filename
		File.Copy(filepath,filename,layoutfilesfolder,newfilename)		
	Else
		File.Copy(filepath,filename,layoutfilesfolder,filename)			
	End If
	lblmessages.Text = lblmessages.Text & filename & " loaded." & CRLF
	code_action("clear")
End Sub
Private Sub btnconvert_Click
	converter.Initialize(False)
	Dim success As Boolean = False
	If rbtojson.Selected = True Then
		success = converter.ConvertBalToJson(layoutfilesfolder, lblcodefilename.text.trim)
	End If
	If rbtobal.Selected = True Then
		converter.ConvertJsonToBal(layoutfilesfolder, lblcodefilename.text.trim)
		success = True
	End If
	If success Then xui.MsgboxAsync("The conversion was succesfull.","Convert")
	code_action("clear")
End Sub

