﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Public tpl_text As String
	Public tpl_var As Map
End Sub
Public Sub Initialize(content As String,varmap As Map)
	tpl_text = content
	tpl_var.Initialize
	tpl_var = varmap
End Sub
Public Sub replace_placeholders As String
	For i = 0 To tpl_var.Size - 1
		Dim key As String = tpl_var.GetKeyAt(i)
		Dim value As String = tpl_var.Get(key)
		If key.EndsWith(".tpl") Then
			value = process_level1_template(key)
		End If
		tpl_text = tpl_text.Replace("[@"& key &"]",value)
	Next
	Return tpl_text
End Sub
Private Sub process_level1_template(mkey As String) As String
	Dim tempfolder As String = B4XPages.MainPage.templatefilesfolder
	Dim varfolder As String = B4XPages.MainPage.varfilesfolder
	Dim fname As String = mkey.SubString2(0,mkey.LastIndexOf("."))
	If File.Exists(tempfolder,mkey) Then
		Dim str As String = File.ReadString(tempfolder,mkey)
		If File.Exists(varfolder,fname & ".var") Then
			Dim mmap As Map = File.ReadMap(varfolder,fname & ".var")
			Dim old_tpl_text As String = tpl_text
			Dim old_tpl_var As Map = tpl_var
			tpl_text = str
			tpl_var = mmap
			process_loops
			str = tpl_text
			For x = 0 To mmap.Size - 1
				Dim k As String = mmap.GetKeyAt(x)
				Dim v As String = mmap.Get(k)
				Log(k)
				Log(v)
				str = str.Replace("[@"& k &"]",v)
				Log(str)
			Next
			tpl_text = old_tpl_text
			tpl_var = old_tpl_var
		End If
		Return str
	End If
	Return ""
End Sub
Public Sub find_placeholders As Map
	Dim mp As Map
	mp.Initialize
	Dim temp As String
	Dim index As Int = 0
	Dim index2 As Int = 0
	Dim eot As Boolean = False
	Do While eot = False
		index = tpl_text.IndexOf2("[@",index)
		If index = -1 Then
			eot = True
		Else
			index2 = tpl_text.IndexOf2("]",index)
			temp = tpl_text.SubString2(index+2,index2)
			If mp.ContainsKey(temp) = False Then
				mp.Put(temp,"")
			End If
			index = index2
		End If
	Loop
	Return mp
End Sub
Public Sub process_loops
	Dim looplst As List
	looplst.Initialize
	For i = 0 To tpl_var.Size - 1
		Dim key As String = tpl_var.GetKeyAt(i)
		If key.StartsWith("loop") Then
			looplst.Add(key)
		End If
	Next
	For z = 0 To looplst.Size - 1
		Dim loopkey As String = looplst.Get(z)
		Dim before As String = tpl_text.SubString2(0,tpl_text.IndexOf("[@"&loopkey&"]"))
		Dim block As String = tpl_text.SubString2(tpl_text.IndexOf("[@"&loopkey&"]"),tpl_text.IndexOf("[/@"&loopkey&"]")+loopkey.Length+4)
		Dim rest As String = tpl_text.SubString(tpl_text.IndexOf("[/@"&loopkey&"]")+loopkey.Length+4)
		Log("loopnumber: " & loopkey)
		Dim newblock As String = process_block(loopkey, block)
		'Log("block = " & CRLF & newblock)
		tpl_text = before & newblock & rest
	Next
End Sub
Public Sub process_block(key As String, resttext As String) As String
	Dim startpos As Int = resttext.IndexOf("[@"&key&"]")
	Dim endpos As Int = resttext.IndexOf("[/@"&key&"]")
	Dim block As String = resttext.SubString2(startpos+key.Length+3,endpos)
	Dim strvarloop As String = tpl_var.Get(""&key&"")
	Dim arrvarloop As List = Regex.split(",",strvarloop)	'placeholders list from loop
	Dim mstr As String = ""
	Dim result As String = ""
	Dim varcnt As Int
	For i = 0 To arrvarloop.Size - 1
		Dim temp As String = block
		result = fill_v_vars(arrvarloop,i,temp)
		Dim v_var As String = arrvarloop.Get(i)
		Dim v_varlst As List = Regex.split(",",tpl_var.Get(v_var))
		varcnt = v_varlst.Size
		If i >= v_varlst.Size Then
			Exit
		End If
		If result <> "" Then
			mstr = mstr & result
		End If
	Next
	If varcnt > arrvarloop.Size Then
		Dim res As String
		res = extra_variables(arrvarloop,varcnt,block)
		If res <> "" Then
			mstr = mstr & res
		End If
	End If
	Return mstr
End Sub
Private Sub fill_v_vars(arrvarloop As List,cnt As Int,temp As String) As String
	Dim res As String = temp
	For j = 0 To arrvarloop.Size - 1
		Dim v_var As String = arrvarloop.Get(j)
		Dim v_varlst As List = Regex.split(",",tpl_var.Get(v_var))
		If cnt >= v_varlst.Size Then
			Exit
		End If
		res = res.Replace("[@"&v_var&"]",v_varlst.Get(cnt))
	Next
	Return res
End Sub
Private Sub extra_variables(arrvarloop As List,vcnt As Int,temp As String) As String
	Dim result As String
	Dim res As String
	For x = arrvarloop.size To vcnt-1
		res = fill_v_vars(arrvarloop,x,temp)
		result = result & res
	Next
	Return result
End Sub
